Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj	(revision 956)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj	(revision 999)
@@ -73,5 +73,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\Ogre\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include;..\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\Ogre\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include;..\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include;&quot;$(LIBXML_HOME)\include&quot;"
 				PreprocessorDefinitions="_WINDOWS;_STLP_USE_DYNAMIC_LIB;OGRE_LIBRARY_IMPORTS;_RELEASE;WIN32;_STLP_RELEASE;GTP_VISIBILITY_MODIFIED_OGRE"
 				RuntimeLibrary="2"
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 973)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 999)
@@ -10,4 +10,9 @@
 #include "TerrainFrameListener.h"
 
+// #include "OgreColladaPrerequisites.h"
+#include "OgreColladaDocument.h"
+#include "OgreColladaScene.h"
+
+
 #include "IVReader.h"
 
@@ -20,7 +25,7 @@
 
 
-/******************************************************/
-/*             EntityState implementation             */
-/******************************************************/
+/*************************************************************/
+/*                EntityState implementation                 */
+/*************************************************************/
 
 
@@ -328,4 +333,37 @@
 												const int index)
 {
+	// Collada
+#if 1
+	ColladaDocument *daeDoc = new ColladaDocument(mSceneMgr);
+
+	String daeName = strCmdLine;
+	if (daeName.empty()) 
+		daeName = "cube.dae";
+
+	// default directory
+	daeName.insert(0, "../../media/models/collada/");
+	LogManager::getSingleton().logMessage("ColladaDocument - import started");
+	
+	// full import
+	if (daeDoc->doImport(daeName))
+	{
+		LogManager::getSingleton().logMessage("yuppi");
+		/**
+		 * build up scene
+		 * if you only want a specific part of the scene graph, you must fetch a scene node
+		 * by its unique node name and give it as parameter
+		 * e.g.
+		 * ColladaSceneNode *box = mScene->getNode("Box2");
+		 * if (box != NULL) box->createOgreInstance(NULL);
+		 */
+		daeDoc->getScene()->createOgreInstance(NULL);
+	}
+
+	LogManager::getSingleton().logMessage("ColladaDocument - import finished");
+	// everything is loaded, we do not need the collada document anymore
+	delete daeDoc;
+#else
+
+
 	mIVReader = new IVReader();
 
@@ -366,5 +404,5 @@
 		return true;
 	}
-
+#endif
 
 	return false;
@@ -602,4 +640,6 @@
 		//mSceneMgr = mRoot->createSceneManager("TerrainSceneManager");
 		mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("KdTreeSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
 	}
 	else
@@ -607,4 +647,6 @@
 		//mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
 		mSceneMgr = mRoot->createSceneManager("OcclusionCullingSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("KdTreeSceneManager");
+		//mSceneMgr = mRoot->createSceneManager("OctreeSceneManager");
 	}
 