Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj	(revision 999)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrain.vcproj	(revision 1003)
@@ -73,5 +73,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\Ogre\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include;..\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include;&quot;$(LIBXML_HOME)\include&quot;"
+				AdditionalIncludeDirectories="&quot;$(OGRE_PATH)\Dependencies\include&quot;;&quot;$(OGRE_PATH)\OgreMain\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\include&quot;;&quot;$(OGRE_PATH)\Dependencies\include\CEGUI&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\include&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\include&quot;;..\..\Ogre\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\include;..\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\include;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\include;&quot;$(LIBXML_HOME)\include&quot;;d:\work\Collada\include"
 				PreprocessorDefinitions="_WINDOWS;_STLP_USE_DYNAMIC_LIB;OGRE_LIBRARY_IMPORTS;_RELEASE;WIN32;_STLP_RELEASE;GTP_VISIBILITY_MODIFIED_OGRE"
 				RuntimeLibrary="2"
@@ -85,8 +85,8 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="OGREMain.LIB CEGUIBase.lib OgreGUIRenderer.lib Plugin_OctreeSceneManager.lib Plugin_VisibilitySceneManager.lib IVReader.lib zdll.lib zziplib.lib"
+				AdditionalDependencies="OGREMain.LIB CEGUIBase.lib OgreGUIRenderer.lib Plugin_OctreeSceneManager.lib Plugin_VisibilitySceneManager.lib IVReader.lib zdll.lib zziplib.lib Plugin_Collada.lib"
 				OutputFile="$(OGRE_PATH)/Samples/Common/bin/Release/TestCullingTerrain.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\Ogre\lib\$(ConfigurationName)&quot;;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\lib;&quot;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\lib\$(ConfigurationName)&quot;;&quot;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\lib\$(ConfigurationName)&quot;"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\Dependencies\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\OgreMain\Lib\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\PlugIns\OctreeSceneManager\bin\$(ConfigurationName)&quot;;&quot;$(OGRE_PATH)\Samples\Common\CEGUIRenderer\lib&quot;;&quot;..\..\Ogre\lib\$(ConfigurationName)&quot;;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\lib;&quot;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\OGRE\lib\$(ConfigurationName)&quot;;&quot;..\..\..\..\..\Lib\Vis\OnlineCullingCHC\IVReader\lib\$(ConfigurationName)&quot;;d:\work\Collada\bin\release"
 				GenerateDebugInformation="TRUE"
 				SubSystem="2"
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 999)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.cpp	(revision 1003)
@@ -329,20 +329,19 @@
 }
 //-----------------------------------------------------------------------
-bool TestCullingTerrainApplication::LoadSceneIV(const String &filename, 
-												SceneNode *root, 
-												const int index)
+bool TestCullingTerrainApplication::LoadSceneCollada(const String &filename, 
+													 SceneNode *root, 
+													 const int index)
 {
 	// Collada
-#if 1
 	ColladaDocument *daeDoc = new ColladaDocument(mSceneMgr);
 
-	String daeName = strCmdLine;
-	if (daeName.empty()) 
-		daeName = "cube.dae";
+	String daeName = filename;
+	//if (daeName.empty()) 
+	//	daeName = "City_1500.dae";
 
 	// default directory
-	daeName.insert(0, "../../media/models/collada/");
+	//daeName.insert(0, "../../media/models/collada/City");
 	LogManager::getSingleton().logMessage("ColladaDocument - import started");
-	
+
 	// full import
 	if (daeDoc->doImport(daeName))
@@ -358,10 +357,24 @@
 		 */
 		daeDoc->getScene()->createOgreInstance(NULL);
-	}
-
-	LogManager::getSingleton().logMessage("ColladaDocument - import finished");
-	// everything is loaded, we do not need the collada document anymore
-	delete daeDoc;
-#else
+
+		// everything is loaded, we do not need the collada document anymore
+		delete daeDoc;
+
+		return true;
+	}
+	else
+	{
+		LogManager::getSingleton().logMessage("ColladaDocument - import failed");
+		return false;
+	}
+
+	return true;
+}
+//-----------------------------------------------------------------------
+bool TestCullingTerrainApplication::LoadSceneIV(const String &filename, 
+												SceneNode *root, 
+												const int index)
+{
+
 
 
@@ -404,5 +417,4 @@
 		return true;
 	}
-#endif
 
 	return false;
@@ -756,9 +768,11 @@
 			LoadSceneIV(fn, mSceneMgr->getRootSceneNode(), i);			
 		}
-		else if (strstr(filename.c_str(), ".collada"))
+		else if (strstr(filename.c_str(), ".dae"))
 		{
 			// load collada files
-		}
-		else if (filename == "terrain")
+			// load iv files
+			LoadSceneCollada(fn, mSceneMgr->getRootSceneNode(), i);		
+		}
+		else //if (filename == "terrain")
 		{
 			// terrain hack
Index: GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h
===================================================================
--- GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h	(revision 973)
+++ GTP/trunk/App/Demos/Vis/HillyTerrain/OGRE/TestCullingTerrainApplication.h	(revision 1003)
@@ -128,4 +128,6 @@
 	bool LoadSceneIV(const String &filename, SceneNode *root, const int index);
 
+	bool LoadSceneCollada(const String &filename, SceneNode *root, const int index);
+
 	bool LoadScene(const String &filename);
 